(function( $ ) {
	'use strict';

	/**
	 * All of the code for your admin-facing JavaScript source
	 * should reside in this file.
	 *
	 * Note: It has been assumed you will write jQuery code here, so the
	 * $ function reference has been prepared for usage within the scope
	 * of this function.
	 *
	 * This enables you to define handlers, for when the DOM is ready:
	 */
	 
	 $(function() {
				
		/* Enable WP Color Picker For Newsletter Widget */
		if($(".pixelform_form_color_picker").length != 0)
			$('.pixelform_form_color_picker').wpColorPicker();
		
		$(document).keyup(function(e) {
			 if (e.keyCode == 27) { // escape key maps to keycode `27`
				if($('.pixelform_form_close_popup').length > 0) $('.pixelform_form_close_popup').click();
			}
		});
		
		$('.up_autoreponder').change(function(e){
			e.preventDefault();
			if($(this).val() == '') return;
			var data = {'action':'pixelform_form_autoresponder_get_list', 'responder' : $(this).val()};
			var el = $(this).closest('p').next();
			var list_id = $(this).data('list_id');
			$.ajax({
				'url' : pixelform_form.ajaxurl,
				'data' : data,
				'type' : 'post',
				'success' : function( res ){
					var result = jQuery.parseJSON(res);
					el.show();
					el.find('select option').remove();
					if(result.error){
						el.find('select').append(jQuery("<option>", { 
							value: 0,
							text : result.error 
						}));
					}else{
						var select = "";
						el.find('select').append(jQuery("<option>", { 
							value: 'null',
							text : 'select'
						}));
						jQuery.each( result.list, function( key, value ) {
							if(key == list_id){
								el.find('select').append(jQuery("<option>", { 
									value: key,
									text : value
								})).val(key);
							}else{
								el.find('select').append(jQuery("<option>", { 
									value: key,
									text : value
								}));	
							}
						});
					}
				}
			});
		});
		
		if($('.up_autoreponder').length > 0){
			$('.up_autoreponder').trigger('change');
		}
		
		
		/* Autoresponder */
		$(document).on('click', '.pixelform_form_autoresponder_list ul li:not(.active)', function(e){
			e.preventDefault();
			$(this).addClass('active');
			var s = $(this).find('a').attr('href');
			var nm = $(this).find('a').text();
			$('body').addClass('pixelform_form_popup_open');
			$(s).removeClass('d-none');
			$('.pixelform_form_autoresponder_popup_inner').find('h3').text(nm);
			$('.pixelform_form_close_popup').data('connect', s);
			$('.pixelform_form_custom_html_appended form').removeClass('d-none');
		});
		
		$('.pixelform_form_close_popup').on('click', function(e){
			e.preventDefault();
			var a = $(this).data('connect');
			$('body').removeClass('pixelform_form_popup_open');
			$('.pixelform_form_autoresponder_form form').addClass('d-none');
			$('.pixelform_form_append_customHtml').addClass('d-none');
			$('a[href='+a+']').parent('li').removeClass('active');
		});
		
		$(document).on('click', '.pixelform_form_autoresponder_list ul li.active', function(e){
			e.preventDefault();
			if(confirm('Are you sure, you want to disconnect this autoresponder ?')){
				var s = $(this).find('a').attr('href');
				s = s.substr(1);
				var obj = $(this);
				var data = { 'action' : 'pixelform_form_autoresponder_connect', 'responder' : s, 'eraser' : 1, 'apikey' : '' };
				$.ajax({
					type:'post',
					url: pixelform_form.ajaxurl,
					data:data,
					success:function(data){
						var result = jQuery.parseJSON(data);
						obj.removeClass('active');
					}
				});
			}
		});
		$('body').on('click', '.pixelform_form_autoresponder_connect', function(e){
			e.preventDefault();
			var responder = $(this).data('responder');
			var data = { 'action' : 'pixelform_form_autoresponder_connect', 'responder' : responder, 'apikey' : '' };
			$('#' + responder).find('span').html('');
			switch(responder){
				case 'ConstantContact':
				
					var apikey = $('#' + responder).find('.apikey').val();
					var secret = $('#' + responder).find('.secret').val();
					var token = $('#' + responder).find('.token').val();
					
					if(apikey == ''){
						$('#' + responder).find('.apikey').next('span').html('API Key is required.');
						return;
					}
					
					if(secret == ''){
						$('#' + responder).find('.secret').next('span').html('Secret is required.');
						return;
					}
					
					if(token == ''){
						$('#' + responder).find('.pixelform_form-cc-generate-token').next('span').html('Token is required.');
						return;
					}
				
					data.apikey = { 'apikey' : apikey, 'secret' : secret, 'token' : token };
										
				break;
				
				case 'SendReach':
				
					var public_key = $('#' + responder).find('.public_key').val();
					var private_key = $('#' + responder).find('.private_key').val();
					
					if(public_key == ''){
						$('#' + responder).find('.public_key').next('span').html('Public Key is required.');
						return;
					}
					
					if(private_key == ''){
						$('#' + responder).find('.private_key').next('span').html('Private Key is required.');
						return;
					}
				
					data.apikey = { 'public_key' : public_key, 'private_key' : private_key };
				
				break;
				
				case 'iContact':
					
					var login_email = $('#' + responder).find('.login_email').val();
					var app_id = $('#' + responder).find('.app_id').val();
					var app_password = $('#' + responder).find('.app_password').val();
					
					if(login_email == ''){
						$('#' + responder).find('.login_email').next('span').html('Login Email is required.');
						return;
					}
					
					if(app_id == ''){
						$('#' + responder).find('.app_id').next('span').html('APP ID is required.');
						return;
					}
					
					if(app_password == ''){
						$('#' + responder).find('.app_password').next('span').html('APP Password is required.');
						return;
					}
				
					data.apikey = { 'login_email' : login_email, 'app_id' : app_id, 'app_password' : app_password };
					
				break;
				
				case 'Infusionsoft':
				
					var host_url = $('#' + responder).find('.host_url').val();
					var api_key = $('#' + responder).find('.api_key').val();
					
					if(host_url == ''){
						$('#' + responder).find('.host_url').next('span').html('Host Url is required.');
						return;
					}
					
					if(api_key == ''){
						$('#' + responder).find('.host_url').next('span').html('API Key is required.');
						return;
					}
				
					data.apikey = { 'host_url' : host_url, 'api_key' : api_key };
					
				break;
				
				case 'Hubspot':
				
					var api_key = $('#' + responder).find('.api_key').val();
									
					if(api_key == ''){
						$('#' + responder).find('.api_key').next('span').html('API Key is required.');
						return;
					}
				
					data.apikey = { 'api_key' : api_key };
					
				break;
				
				case 'Aweber':
				
					var aweber_code = $('#' + responder).find('.aweber_code').val();
									
					if(aweber_code == ''){
						$('#' + responder).find('.aweber_code').next('span').html('Aweber Code is required.');
						return;
					}
				
					data.apikey = { 'aweber_code' : aweber_code };
					
				break;
				
				case 'Sendlane':
				
					var subdomain = $('#' + responder).find('.subdomain').val();
					var api_key = $('#' + responder).find('.api_key').val();
					var hash_key = $('#' + responder).find('.hash_key').val();
					
					if(subdomain == ''){
						$('#' + responder).find('.subdomain').next('span').html('User Url is required.');
						return;
					}
					
					if(api_key == ''){
						$('#' + responder).find('.api_key').next('span').html('API Key is required.');
						return;
					}
					
					if(hash_key == ''){
						$('#' + responder).find('.hash_key').next('span').html('Hash Key is required.');
						return;
					}
				
					data.apikey = { 'subdomain' : subdomain, 'api_key' : api_key, 'hash_key' : hash_key };
					
				break;
				
				case 'Benchmark':
					var apikey = $('#' + responder).find('.apikey').val();
					if(username == ''){
						$('#' + responder).find('.apikey').next('span').html('API Key is required.');
						return;
					}
					data.apikey = { 'apikey' : apikey };
					
				break;
				
				case 'Sendloop':
					var api_key = $('#' + responder).find('.api_key').val();
					var subdomain = $('#' + responder).find('.subdomain').val();
					
					if(api_key == ''){
						$('#' + responder).find('.api_key').next('span').html('API Key is required.');
						return;
					}
					
					if(subdomain == ''){
						$('#' + responder).find('.subdomain').next('span').html('Subdomain is required.');
						return;
					}
				
					data.apikey = { 'api_key' : api_key, 'subdomain' : subdomain };
					
				break;

				case 'Madmimi':
				
					var username = $('#' + responder).find('.username').val();
					var api_key = $('#' + responder).find('.api_key').val();
					
					if(list_nm == ''){
						alert('User Url is required.');
						return;
					}
					
					if(api_key == ''){
						alert('API Key is required.');
						return;
					}
				
					data.apikey = { 'username' : username, 'api_key' : api_key };
					
				break;
				
				case 'Mailchimp':
					var api_key = $('#' + responder).find('.api_key').val();
					if(api_key == ''){
						$('#' + responder).find('.api_key').next('span').html('API Key is required.');
						return;
					}
					data.apikey = { 'api_key' : api_key };
				break;
				
				case 'CampaignMonitor':
					
					var api_key = $('#' + responder).find('.api_key').val();
					var client_id = $('#' + responder).find('.client_id').val();
									
					if(api_key == ''){
						$('#' + responder).find('.api_key').next('span').html('API Key is required.');
						return;
					}
					
					if(client_id == ''){
						$('#' + responder).find('.client_id').next('span').html('Client Id is required.');
						return;
					}
				
					data.apikey = { 'api_key' : api_key, 'client_id' : client_id };
					
				break;
				
				case 'Sendinblue':
					
					var api_key = $('#' + responder).find('.api_key').val();
									
					if(api_key == ''){
						$('#' + responder).find('.api_key').next('span').html('API Key is required.');
						return;
					}
				
					data.apikey = { 'api_key' : api_key };
					
				break;
				
				case 'GetResponse':
					
					var api_key = $('#' + responder).find('.api_key').val();
									
					if(api_key == ''){
						$('#' + responder).find('.api_key').next('span').html('API Key is required.');
						
						return;
					}
				
					data.apikey = { 'api_key' : api_key };
					
				break;
				
				case 'ActiveCampaign':
					
					var api_key = $('#' + responder).find('.api_key').val();
					var api_url = $('#' + responder).find('.api_url').val();
					
					if(api_url == ''){
						$('#' + responder).find('.api_url').next('span').html('API Url is required.');
						return;
					}
					
					if(api_key == ''){
						
						$('#' + responder).find('.api_key').next('span').html('API Key is required.');
						return;
					}
					
					data.apikey = { 'api_key' : api_key, 'api_url' : api_url };
					
				break;
				
				case 'GoToWebinar':
					
					var consumer_key = $('#' + responder).find('.consumer_key').val();
					var consumer_secret = $('#' + responder).find('.consumer_secret').val();
					var user_id = $('#' + responder).find('.user_id').val();
					var password = $('#' + responder).find('.password').val();
									
					if(consumer_key == ''){
						$('#' + responder).find('.consumer_key').next('span').html('Consumer Key is required.');
						return;
					}
					
					if(consumer_secret == ''){
						$('#' + responder).find('.consumer_secret').next('span').html('Consumer Secret is required.');
						return;
					}
					
					if(user_id == ''){
						$('#' + responder).find('.user_id').next('span').html('User Id is required.');
						return;
					}
					
					if(password == ''){
						$('#' + responder).find('.password').next('span').html('Password is required.');
						return;
					}
				
					data.apikey = { 'consumer_key' : consumer_key, 'consumer_secret' : consumer_secret, 'user_id' : user_id, 'password' : password, };
					
				break;
				
				case 'Mailpoet':
					data.apikey = { 'mailpoet' : 'activate' };
				break;
				
				case 'Verticalresponse':
				
					var accesstoken = $('#' + responder).find('.accesstoken').val();
					
					if(accesstoken == ''){
						$('#' + responder).find('.accesstoken').next('span').html('Accesstoken is required.');
						return;
					}
					
					data.apikey = { 'accesstoken' : accesstoken };
				break;
				
				case 'CustomHTML':
					
					var customhtml = $('#' + responder).find('.customhtml_code').val();
					var form_name = $('#' + responder).find('.form_name').val();

					if(form_name == ''){
						$('#' + responder).find('.form_name').next('span').html('Form Name is required.');
						return;
					}
					
					if(customhtml == ''){
						$('#' + responder).find('.customhtml_code').next('span').html('CustomHTML Code is required.');
						return;
					}
					
					var form_id = Math.floor(Math.random()*1000) + 1;
					
					data.apikey = { 'form_id': form_id, 'customhtml' : customhtml, 'form_name' : form_name };
					
					localStorage.setItem('Msglock_customhtml', JSON.stringify( data.apikey ));
					
				break;
				
				case 'ConvertKit':
					
					var api_key = $('#' + responder).find('.api_key').val();
					var api_secret = $('#' + responder).find('.api_secret').val();
					
					if(api_key == ''){
						$('#' + responder).find('.api_key').next('span').html('API Key is required.');
						return;
					}
					if(api_secret == ''){
						$('#' + responder).find('.api_secret').next('span').html('API Secret is required.');
						return;
					}
					
					data.apikey = { 'api_key' : api_key, 'api_secret' : api_secret };
					
				break;
				
				case 'MailerLite':
					
					var api_key = $('#' + responder).find('.api_key').val();
					
					if(api_key == ''){
						$('#' + responder).find('.api_key').next('span').html('API Key is required.');
						return;
					}
					
					data.apikey = { 'api_key' : api_key };
					
				break;
				
				case 'MarketHero':
					
					var api_key = $('#' + responder).find('.api_key').val();
					
					if(api_key == ''){
						$('#' + responder).find('.api_key').next('span').html('API Key is required.');
						return;
					}
					
					data.apikey = { 'api_key' : api_key };
					
				break;
				
				case 'Drip':
				
					var account_id = $('#' + responder).find('.account_id').val();
					var api_token = $('#' + responder).find('.api_token').val();
					
					if(account_id == ''){
						$('#' + responder).find('.account_id').next('span').html('Account Id is required.');
						return;
					}
					
					if(api_token == ''){
						$('#' + responder).find('.api_token').next('span').html('API Token is required.');
						return;
					}
					
					data.apikey = { 'account_id' : account_id, 'api_token' : api_token };
				
				break;
				
				case 'Cleverreach':
				
					var client_id = $('#' + responder).find('.client_id').val();
					var login     = $('#' + responder).find('.user_login').val();
					var passw     = $('#' + responder).find('.user_pass').val();
					
					if(client_id == ''){
						$('#' + responder).find('.client_id').next('span').html('Client ID is required.');
						return;
					}
					
					if(login == ''){
						$('#' + responder).find('.user_login').next('span').html('Login email is required.');
						return;
					}
					
					if(passw == ''){
						$('#' + responder).find('.user_pass').next('span').html('Password is required.');
						return;
					}
					
					data.apikey = { 'client_id' : client_id, 'user_login' : login, 'user_pass' : passw };
				
				break;
				
				case 'Sendiio':
					var api_token = $('#' + responder).find('.api_token').val();
					var api_secret = $('#' + responder).find('.api_secret').val();
					
					if(api_token == ''){
						$('#' + responder).find('.api_token').next('span').html('API Token is required.');
						return;
					}
					
					if(api_secret == ''){
						$('#' + responder).find('.api_secret').next('span').html('API Secret is required.');
						return;
					}
				
					data.apikey = { 'api_token' : api_token, 'api_secret' : api_secret };
				break;
				
				case 'Mailvio':
				
					var api_key = $('#' + responder).find('.api_key').val();
					
					if(api_key == ''){
						alert('API Key is required.');
						return;
					}
				
					data.apikey = { 'api_key' : api_key };
				break;
			}
			
			$('#' + responder).find('.pixelform_form_loader_img').css({'display': 'inline-block'});
			
			$.ajax({
				type:'post',
				url: pixelform_form.ajaxurl,
				data:data,
				success:function(data){
					console.log(data);
					var result = jQuery.parseJSON(data);
					$('#' + responder).find('.pixelform_form_loader_img').css({'display': 'none'});
					if(result.status){
						$('#' + responder).find('.pixelform_form_autoresponder_connect').next().next().css({'color':'green'});
						$('#' + responder).find('.pixelform_form_autoresponder_connect').next().next().text(result.msg);
						$('body').removeClass('pixelform_form_popup_open');
						$('.pixelform_form_autoresponder_form form').addClass('d-none');
					}else{
						$('#' + responder).find('.pixelform_form_autoresponder_connect').next().next().text(result.msg);
					}
				}
			});
		});
		
		$('.ml_add_customHtml_form').on('click', function(e){
			e.preventDefault();
			var id = Math.floor(Math.random()*1000) + 1;
			var html = '';
			html += '<div class="pixelform_form_custom_html" data-form_id="'+id+'">';
				html += '<a class="pixelform_form_close_custom_html_form" href="" title="Remove Form"><i class="fas fa-window-close"></i></a>';
				html += '<form action="" id="CustomHTML_'+id+'" >';
					html += '<div class="hs_right_section">';
						html += '<div class="form-group">';
							html += '<label>Form Name </label>';
							html += '<input type="text" value="" placeholder="Enter Form Name" class="form_name form-control">';
							html += '<span class="pixelform_form_error_msg"></span>';
						html += '</div>';
						html += '<div class="form-group">';
							html += '<label>Enter your custom HTML form below and click on submit.</label>';
							html += '<textarea class="customhtml_code form-control"></textarea>';
							html += '<span class="pixelform_form_error_msg"></span>';
						html += '</div>';
						html += '<div class="form-group">';
							html += '<input class="pixelform_form_store_customhtml form-control" type="submit" data-responder="CustomHTML_'+id+'">';
							html += '<div class="pixelform_form_loader_img"><div></div><div></div></div><span class="pixelform_form_error_msg"></span>';
						html += '</div>';
					html += '</div>';
				html += '</form>';
			html += '</div>';
			$('.pixelform_form_custom_html_appended').prepend(html);
		});
		
		$(document).on('click', '.pixelform_form_remove_customHTML', function(e){
			var obj = $(this);
			var form_id = $(this).parent('.pixelform_form_custom_html').data('form_id');
			if(confirm('Are you sure, do you want to remove the form?')){
				var data = { 'action' : 'pixelform_form_autoresponder_connect', 'form_id' : form_id, 'remove' : true, 'responder' : 'CustomHtml' };
				$.ajax({
					type:'post',
					url: pixelform_form.ajaxurl,
					data:data,
					success:function(data){
						var result = jQuery.parseJSON(data);
						if(result.status){
							obj.parent().remove();
						}else{
						}
					}
				});
			}
		});
		
		$(document).on('click', '.pixelform_form_close_custom_html_form', function(e){
			e.preventDefault();
			$(this).parent().remove();
		});
		
		$(document).on('click', '.pixelform_form_store_customhtml', function(e){
			e.preventDefault();
			var responder = $(this).data('responder');
			var customhtml = $('#' + responder).find('.customhtml_code').val();
			var form_name = $('#' + responder).find('.form_name').val();
			var form_id = $(this).parents('.pixelform_form_custom_html').data('form_id');
			
			
			if(form_name == ''){
				$('#' + responder).find('.form_name').next('span').html('Form Name is required.');
				return;
			}
			
			if(customhtml == ''){
				$('#' + responder).find('.customhtml_code').next('span').html('CustomHTML Code is required.');
				return;
			}
			
			var data = { 'action' : 'pixelform_form_autoresponder_connect', 'form_id': form_id, 'customhtml' : window.btoa(unescape(encodeURIComponent(customhtml))), 'form_name' : form_name, 'add' : true, 'responder' : 'CustomHtml' };
			var obj = $(this);
			$('#' + responder).find('.pixelform_form_loader_img').css({'display': 'inline-block'});
			$.ajax({
				type:'post',
				url: pixelform_form.ajaxurl,
				data:data,
				success:function(data){
					var result = jQuery.parseJSON(data);
					$('#' + responder).find('.pixelform_form_loader_img').css({'display': 'none'});
					if(result.status){
						obj.parents('.pixelform_form_custom_html').find('.pixelform_form_close_custom_html_form').addClass('pixelform_form_remove_customHTML');
						$('#' + responder).find('.pixelform_form_store_customhtml').next().next().css({'color':'green'});
						$('#' + responder).find('.pixelform_form_store_customhtml').next().next().text(result.msg);
					}else{
						$('#' + responder).find('.pixelform_form_store_customhtml').next().next().text(result.msg);
					}
				}
			});
		});
		/* Autoresponder */
		
		//Constant Contact Generate Token
		$('.pixelform_form-cc-generate-token').on('click', function(){
				var apikey = $('#ConstantContact').find('.apikey').val();
				var secret = $('#ConstantContact').find('.secret').val();
				
				if(apikey == ''){
					$('#ConstantContact').find('.apikey').next('span').html('API Key is required.');
					return false;
				}
				
				if(secret == ''){
					$('#ConstantContact').find('.secret').next('span').html('Secret is required.');
					return false;
				}
				
				var red_url = $('#ConstantContact').find('.pixelform_form-cc-generate-token').attr('href');

				var cc_url = 'https://api.cc.email/v3/idfed?client_id='+apikey+'&scope=contact_data&response_type=code&redirect_uri='+red_url+'';
				
				$('#ConstantContact').find('.pixelform_form-cc-generate-token').attr('href', cc_url);
		       
				$.ajax({
					'url' : pixelform_form.ajaxurl,
					'type' : 'post',
					'data' : {
						action: 'set_cc_session',
						apikey : apikey,
						secret : secret
					},
					
					success:function(res){
						console.log(res);
					}
				});
		});
		
	 });
	

})( jQuery );