<?php
/** 
 * Pixel Form
*/

add_action( 'vc_before_init', 'pixelform_form_shortcode_map' );
function pixelform_form_shortcode_map(){
	global $wpdb;
	$table_name = $wpdb->prefix . 'pixelform_form_forms';
	$row = $wpdb->get_results ( "SELECT Name,ID FROM $table_name ORDER BY Name" );
	$forms['None'] = '0';
	if(!empty($row)){
		foreach( $row as $form ){
			$forms[$form->Name] = $form->ID;
		}
	}else{ $forms = array( '0' => 'No form' ); }
	
	//Get Custom Form From Autoresponders
	$CustomHtml = get_option('pixelform_form_custom_html_settings');
	if(!empty($CustomHtml)){
		foreach($CustomHtml as $custom_form){
			$form_name = $custom_form['form_name'];
			$forms[$form_name] = 'custom_form';
		}
	}
	
   vc_map( array(
      "name" => __( "Pixel Form", "pixelform_form" ),
      "base" => "pixelform_form",
	  "category" => __('Pixel Form','pixelform_form'), 
	  "icon"	 => plugin_dir_url( __FILE__ ) . 'images/Form.png',
      "params" => array(
         array(
            "type" => "dropdown",
            "holder" => "div",           
            "heading" => __( "Select Form", "pixelform_form" ),
            "param_name" => "form_id",
			'admin_label' => false,
			"value" => $forms,
			"description" => __('<a href="'.get_admin_url().'admin.php?page=pixelform_form-forms" target=_blank>Create Form.</a>',"pixelform_form")
           )
      ),
   ) );
}

/**
 * Pixel Form
*/
add_shortcode('pixelform_form','pixelform_form_shortcode_view');
function  pixelform_form_shortcode_view($atts,$content){
	extract( shortcode_atts(
		array(										
			'form_id'=>''
		   ),$atts ) );
	$css = '';
	$id = uniqid();
	if( isset($form_id) ){
		$render = '';
		if($form_id == 'custom_form'){
			$CustomHtml = get_option('pixelform_form_custom_html_settings');
			$render .= '<div class="pixelform_form_render"><div class="row">';
			foreach($CustomHtml as $custom_form){
				$render .= base64_decode($custom_form['customhtml']);
			}
			$render .= '</div></div>';
		}else{
		global $wpdb;
		$table_name = $wpdb->prefix . 'pixelform_form_forms';
		if( !empty($form_id) ){
			$row = $wpdb->get_results ( "SELECT * FROM  $table_name WHERE ID = $form_id" );
		}
		
		if(empty($row)){
			return;
		}
		
		 $messages 		   = json_decode($row[0]->Messages);
		 $success 	       = !empty($messages[0]) ? $messages[0] : 'Thank you for your message. It has been sent.';
		 $error 	   	   = !empty($messages[1]) ? $messages[1] : 'There was an error trying to send your message. Please try again later.';
		 $validation 	   = !empty($messages[2]) ? $messages[2] : 'One or more fields have an error. Please check and try again.';
		 $required 	 	   = !empty($messages[3]) ? $messages[3] : 'The field is required.';
		 $email_validation = !empty($messages[4]) ? $messages[4] : 'Invalid email address.';
		 
		 $addi_sett = json_decode($row[0]->Additional_Settings);
		 if( !empty($addi_sett->custom_action) ){
			$btn_cls = '';
			$type = "submit";
		 }else{
			$btn_cls = ($row[0]->Render_As == 'autoresponder') ? 'pixelform_form_newsletter_submit' : ($row[0]->Render_As == 'both' ? 'pixelform_form_submit_both' : 'pixelform_form_submit' );
			$type = "button";
		 }
		
		$btn_cls .= isset($addi_sett->padding_type) && $addi_sett->padding_type == 'default' ? ' pixelform_form_button_default_size' : '';
		 
		 $add_cls = isset($addi_sett->fields_size) && $addi_sett->fields_size == 'yes' ? ' pixelform_form_big_input_box' : '';
		 $add_cls .= isset($addi_sett->label_on_border) && $addi_sett->label_on_border == 'yes' ? ' pixelform_form-label-on-border' : '';
		 
		 $render .= !empty($addi_sett->custom_action) ? '<form method="post" action="'.esc_url($addi_sett->custom_action).'">' : '';
		 $render .= '<div class="pixelform_form_render'.esc_attr($add_cls).' pixelform_form_'.esc_attr($id).' row">';
		 
		 $render .= '<div class="pixelform_form_messages" style="display:none;">
						<input type="hidden" value="'.esc_html($success).'">
						<input type="hidden" value="'.esc_html($error).'">
						<input type="hidden" value="'.esc_html($validation).'">
						<input type="hidden" value="'.esc_html($required).'">
						<input type="hidden" value="'.esc_html($email_validation).'">
					</div>';
					
		 if( !empty($row) && ($row[0]->Render_As == 'autoresponder' || $row[0]->Render_As == 'both') ){
			
			$res = json_decode($row[0]->Responder);
			
			$render .= '<input type="hidden" class="responder_data" data-formid="'.esc_html($form_id).'" data-responder="'.esc_attr($res->responder).'" data-name_field="'.esc_attr($res->name_field).'" data-email_field="'.esc_attr($res->email_field).'" data-listType="'.esc_attr($res->listType).'">';
			$render .= '<div class="col-12 pixelform_form_newsletter_wrapper"><div class="row">';
		 }
		 
		if(isset($addi_sett->form_inside) && $addi_sett->form_inside == 'yes'){
			$col_cls =  'pixelform_form-btn-inside-input';
			$btn_wrap =  'pixelform_form-btn-inside-button';
		}else{ $col_cls = $btn_wrap = ''; }
		 
		 if( !empty($row[0]->Data) ){
			 $data = json_decode(base64_decode($row[0]->Data));
			 foreach( $data as $fields ){
			 $col = $fields->column_data->columns;
				$render .= '<div class="col-xs-12 col-md-'.esc_attr($col).' col-lg-'.esc_attr($col).' '.$col_cls.'">';
					foreach( $fields as $k => $v ){
						$fieldType = explode('_',$k)[0];
						$custom_cls = !empty($v->className) ? ' '.$v->className : '';
						if( $fieldType != 'column' ){
							switch( $fieldType ){
								case 'text':
									$required = ($v->required == 1) ? ' pixelform_form_req_field' : '';
									$render .= '<div class="form-group'.$custom_cls.'" data-fieldType="text">';
									$render .= !empty($v->label) ? '<label class="pixelform_form_label">'.esc_html($v->label).'</label>' : '';
									$render .= !empty($v->help) ? '<div class="pixelform_form_input_wrap">' : '';
									$render .= '<input type="text" class="form-control'.esc_attr($required).'" placeholder="'.esc_attr($v->placeholder).'" name="'.esc_attr($v->name).'">';
									$render .= !empty($v->help) ? '<div class="pixelform_form_input_info">
												<span class="pixelform_form_input_info_icon"><i class="fa fa-info-circle" aria-hidden="true"></i></span>
												<div class="pixelform_form_input_tooltip">'.esc_html($v->help).'</div>
											</div></div>' : '';
									$render .= '</div>';
								break;
								
								case 'email':
									$required = ($v->required == 1) ? ' pixelform_form_req_field' : '';
									$render .= '<div class="form-group'.$custom_cls.'" data-fieldType="email">';
									$render .= !empty($v->label) ? '<label class="pixelform_form_label">'.esc_html($v->label).'</label>' : '';
									$render .= !empty($v->help) ? '<div class="pixelform_form_input_wrap">' : '';
									$render .= '<input type="text" class="form-control'.esc_attr($required).'" placeholder="'.esc_attr($v->placeholder).'" name="'.esc_attr($v->name).'">';
									$render .= !empty($v->help) ? '<div class="pixelform_form_input_info">
												<span class="pixelform_form_input_info_icon"><i class="fa fa-info-circle" aria-hidden="true"></i></span>
												<div class="pixelform_form_input_tooltip">'.esc_html($v->help).'</div>
											</div></div>' : '';
									$render .= '</div>';
								break;
								
								case 'textarea':
									$required = ($v->required == 1) ? ' pixelform_form_req_field' : '';
									$render .= '<div class="form-group'.$custom_cls.'" data-fieldType="textarea">';
									$render .= !empty($v->label) ? '<label class="pixelform_form_label">'.esc_html($v->label).'</label>' : '';
									$render .= !empty($v->help) ? '<div class="pixelform_form_input_wrap">' : '';
									$render .= '<textarea class="form-control'.esc_attr($required).'" placeholder="'.esc_attr($v->placeholder).'" name="'.esc_attr($v->name).'"></textarea>';
									$render .= !empty($v->help) ? '<div class="pixelform_form_input_info">
												<span class="pixelform_form_input_info_icon"><i class="fa fa-info-circle" aria-hidden="true"></i></span>
												<div class="pixelform_form_input_tooltip">'.esc_html($v->help).'</div>
											</div></div>' : '';
									$render .= '</div>';
									
								break;
								
								case 'checkboxgroup':
									$inline = ($v->inline == 1) ? ' checkbox-inline' : '';
									$render .= '<div class="checkbox form-group'.$custom_cls.'" data-fieldType="checkboxgroup">';
									$render .= !empty($v->label) ? '<label class="pixelform_form_label">'.esc_html($v->label).'</label>' : '';
									$render .= !empty($v->help) ? '<div class="pixelform_form_input_wrap">' : '';
									foreach( $v->checkboxoptions as $options ){
										$render .= '<label class="'.esc_attr($inline).' check_optn"><input type="checkbox" name="'.esc_attr($v->name).'[]" value="'.esc_attr($options->value).'">'.esc_html($options->label).'</label>';
									}
									$render .= !empty($v->help) ? '<div class="pixelform_form_input_info">
												<span class="pixelform_form_input_info_icon"><i class="fa fa-info-circle" aria-hidden="true"></i></span>
												<div class="pixelform_form_input_tooltip">'.esc_html($v->help).'</div>
											</div></div>' : '';
									$render .= '</div>';
								break;
								
								case 'select':
									$multiple = ($v->multiple == 1) ? 'multiple' : '';
									$render .= '<div class="form-group'.$custom_cls.'" data-fieldType="select">';
									$render .= !empty($v->label) ? '<label class="pixelform_form_label">'.esc_html($v->label).'</label>' : '';
									$render .= !empty($v->help) ? '<div class="pixelform_form_input_wrap">' : '';
									$render .= '<select class="form-control" '.esc_attr($multiple).'>';
												foreach( $v->selectoptions as $options ){
													$render .= '<option value="'.esc_attr($options->value).'">'.esc_html($options->label).'</option>';
												}
									$render .= '</select>';
									$render .= !empty($v->help) ? '<div class="pixelform_form_input_info">
												<span class="pixelform_form_input_info_icon"><i class="fa fa-info-circle" aria-hidden="true"></i></span>
												<div class="pixelform_form_input_tooltip">'.esc_html($v->help).'</div>
											</div></div>' : '';
									$render .= '</div>';
								break;
								
								case 'radiogroup':
									$inline = ($v->inline == 1) ? ' radio-inline' : '';
									$render .= '<div class="radio form-group'.$custom_cls.'" data-fieldType="radiogroup">';
									$render .= !empty($v->label) ? '<label class="pixelform_form_label">'.esc_html($v->label).'</label>' : '';
									$render .= !empty($v->help) ? '<div class="pixelform_form_input_wrap">' : '';
									foreach( $v->radiooptions as $options ){
										$render .= '<label class="'.esc_attr($inline).' radio_optn"><input type="radio" name="'.esc_attr($v->name).'" value="'.esc_attr($options->value).'">'.esc_html($options->label).'</label>';
									}
									$render .= !empty($v->help) ? '<div class="pixelform_form_input_info">
												<span class="pixelform_form_input_info_icon"><i class="fa fa-info-circle" aria-hidden="true"></i></span>
												<div class="pixelform_form_input_tooltip">'.esc_html($v->help).'</div>
											</div></div>' : '';
									$render .= '</div>';
								break;
								
								case 'number':
									$required = ($v->required == 1) ? ' pixelform_form_req_field' : '';
									$render .= '<div class="form-group'.$custom_cls.'" data-fieldType="number">';
									$render .= !empty($v->label) ? '<label class="pixelform_form_label">'.esc_html($v->label).'</label>' : '';
									$render .= !empty($v->help) ? '<div class="pixelform_form_input_wrap">' : '';
									$render .= '<input type="number" class="form-control'.esc_attr($required).'" placeholder="'.esc_attr($v->placeholder).'" name="'.esc_attr($v->name).'">';
									$render .= !empty($v->help) ? '<div class="pixelform_form_input_info">
												<span class="pixelform_form_input_info_icon"><i class="fa fa-info-circle" aria-hidden="true"></i></span>
												<div class="pixelform_form_input_tooltip">'.esc_html($v->help).'</div>
											</div></div>' : '';
									$render .= '</div>';
								break;
								
								case 'date':
									$required = ($v->required == 1) ? ' pixelform_form_req_field' : '';
									$render .= '<div class="form-group'.$custom_cls.'" data-fieldType="date">';
									$render .= !empty($v->label) ? '<label class="pixelform_form_label">'.esc_html($v->label).'</label>' : '';
									$render .= !empty($v->help) ? '<div class="pixelform_form_input_wrap">' : '';
									$render .= '<input type="text" class="form-control'.esc_attr($required).' custom_date" name="'.esc_attr($v->name).'">';
									$render .= !empty($v->help) ? '<div class="pixelform_form_input_info">
												<span class="pixelform_form_input_info_icon"><i class="fa fa-info-circle" aria-hidden="true"></i></span>
												<div class="pixelform_form_input_tooltip">'.esc_html($v->help).'</div>
											</div></div>' : '';
									$render .= '</div>';
								break;
								
								case 'fileupload':
									$required = ($v->required == 1) ? ' pixelform_form_req_field' : '';
									$multiple = ($v->multifiles == 1) ? 'multiple' : '';
									$render .= '<div class="form-group'.$custom_cls.'" data-fieldType="fileupload">';
									$render .= !empty($v->label) ? '<label class="pixelform_form_label">'.esc_html($v->label).'</label>' : '';
									$render .= !empty($v->help) ? '<div class="pixelform_form_input_wrap">' : '';
									$render .= '<input type="file" class="form-control'.esc_attr($required).'" name="'.esc_attr($v->name).'" '.esc_attr($multiple).'>';
									$render .= !empty($v->help) ? '<div class="pixelform_form_input_info">
												<span class="pixelform_form_input_info_icon"><i class="fa fa-info-circle" aria-hidden="true"></i></span>
												<div class="pixelform_form_input_tooltip">'.esc_html($v->help).'</div>
											</div></div>' : '';
									$render .= '</div>';
								break;
								
								case 'button':
									$btn_cls .= !empty($v->className) ? ' '.$v->className : '';
									$required = (isset($v->required) && $v->required == 1) ? ' pixelform_form_req_field' : '';
									
									$render .= '<div class="form-group'.$custom_cls.' '.$btn_wrap.'" data-fieldType="button"><button type="'.esc_attr($type).'" class="pixelform_form_btn_'.$id.' pixelform_form-btn '.esc_attr($btn_cls).'" name="'.esc_attr($v->name).'" data-form_id="'.$form_id.'">'.esc_html($v->label).'';
									$style = !empty($v->label) ? 'style=margin-left:10px;' : '';
									$render .= !empty($v->icon) ? '<span class="'.esc_attr($v->icon).'" '.esc_attr($style).'></span>' : '';
									//Loader
									$render .= '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 100 100" class="pixelform_form-btn-loader">
											<g>
											  <path d="M50 23A27 27 0 1 0 72.5667987569433 35.17638391405044" fill="none" stroke="#e15b64" stroke-width="4"></path>
											  <path d="M49 18L49 28L54 23L49 18" fill="#e15b64"></path>
											  <animateTransform attributeName="transform" type="rotate" repeatCount="indefinite" dur="0.819672131147541s" values="0 50 50;360 50 50" keyTimes="0;1"></animateTransform>
											</g></svg>';
									$render .= '</button></div>';
								break;
							}
						}
					}
					$render .= '</div>';
				}
			}
			
			if( !empty($row) && ($row[0]->Render_As == 'autoresponder' || $row[0]->Render_As == 'both') ){
				$render .= '</div></div>';
			}
			
			$render .= '<div class="pixelform_form_msg" style="display:none"><p></p></div>';
			$render .= '</div>';

			$render .= !empty($addi_sett->custom_action) ? '</form>' : '';
			
				$btn_id = isset($id) ? $id : '';
				$css .= '.pixelform_form_'.esc_attr($id).' .form-group .pixelform_form_btn_'.$btn_id.'{';
				
					$css .= (!empty($addi_sett->back_color)) ? 'background: '.esc_html($addi_sett->back_color).'!important;border-color: '.esc_html($addi_sett->back_color).';' : '';
					
					$css .= !empty($addi_sett->font_size) ? 'font-size:'.esc_attr(rtrim($addi_sett->font_size,'px')).'px;' : '';
					$css .= !empty($addi_sett->font_weight) ? 'font-weight:'.esc_attr($addi_sett->font_weight).';' : '';
					$css .= !empty($addi_sett->txt_color) ? 'color:'.esc_attr($addi_sett->txt_color).'!important;' : '';
					if(isset($addi_sett->padding_type) && $addi_sett->padding_type == 'custom'){
					$css .= !empty($addi_sett->btn_padding) ? 'padding: '.esc_html($addi_sett->btn_padding).';' : '';
					}
					
					if(isset($addi_sett->custom_border) && $addi_sett->custom_border == 'yes'){
					$css .= !empty($addi_sett->bb_width) ? 'border: '.rtrim($addi_sett->bb_width,'px').'px solid '.$addi_sett->btn_border_color.';' : '';
					$css .= !empty($addi_sett->btn_radius) ? 'border-radius: '.esc_html($addi_sett->btn_radius).';' : '';
					}
					
				$css .= '}';
				//Button Hover
				if(isset($addi_sett->button_hover) && $addi_sett->button_hover=='yes'){
					$css .= '.pixelform_form_'.esc_attr($id).' .form-group .pixelform_form_btn_'.$btn_id.':hover{';
					$css .= !empty($addi_sett->hr_bck_color) ? 'background: '.esc_html($addi_sett->hr_bck_color).'!important;' : '';
					$css .= !empty($addi_sett->hr_txt_color) ? 'color: '.esc_html($addi_sett->hr_txt_color).'!important;' : '';
					$css .= !empty($addi_sett->hr_btn_border_color) ? 'border-color: '.esc_html($addi_sett->hr_btn_border_color).';' : '';
					$css .= isset($addi_sett->pixelform_form_hr_disab_shadow) && !empty($addi_sett->pixelform_form_hr_disab_shadow == 'yes') ? 'box-shadow: none;' : '';
					$css .= '}';
				}
				//Input
				$css .= '.pixelform_form_'.esc_attr($id).' .form-group .form-control,.pixelform_form-label-on-border .radio, .pixelform_form-label-on-border .checkbox{';
					$css .= !empty($addi_sett->inp_back_clr) ? 'background: '.esc_attr($addi_sett->inp_back_clr).';' : '';
					$css .= !empty($addi_sett->inp_border_clr) ? 'border-color: '.esc_attr($addi_sett->inp_border_clr).';' : '';
					$css .= !empty($addi_sett->inp_fnt_clr) ? 'color: '.esc_attr($addi_sett->inp_fnt_clr).';' : '';
					$css .= !empty($addi_sett->input_radius) ? 'border-radius: '.esc_html($addi_sett->input_radius).';' : '';
				$css .= '}';
				
				$css .= '.pixelform_form_'.esc_attr($id).' .form-group{';
					$css .= !empty($addi_sett->input_margin) ? 'margin-bottom: '.esc_html($addi_sett->input_margin).'px;' : '';
				$css .= '}';
								
				//Placeholder CSS
				if(!empty($addi_sett->input_place_color)){
					$css .= '.pixelform_form_'.esc_attr($id).' .form-control::-webkit-input-placeholder { 
								  color: '.esc_attr($addi_sett->input_place_color).';
								}
								.pixelform_form_'.esc_attr($id).' .form-control::-moz-placeholder { 
								  color: '.esc_attr($addi_sett->input_place_color).';
								}
								.pixelform_form_'.esc_attr($id).' .form-control:-ms-input-placeholder { 
								  color: '.esc_attr($addi_sett->input_place_color).';
								}
								.pixelform_form_'.esc_attr($id).' .form-control:-moz-placeholder {
								  color: '.esc_attr($addi_sett->input_place_color).';
								}';
				}
				
				$css .= '.pixelform_form_'.esc_attr($id).' label.pixelform_form_label,.pixelform_form_'.esc_attr($id).' label.check_optn{';
					$css .= !empty($addi_sett->inp_fnt_clr) ? 'color: '.esc_attr($addi_sett->inp_fnt_clr).';' : '';
				$css .= '}';
				
			global $fb_internal_css;
			$fb_internal_css[] = $css;
			
		}
		return $render;
	}
}