<?php
namespace ElementorLeadcapture;
use \Elementor\Controls_Manager;
use \Elementor\Group_Control_Border;
use \Elementor\Group_Control_Box_Shadow;
use \Elementor\Group_Control_Typography;
use \Elementor\Widget_Base;
use \Elementor\Repeater;
use Elementor\Icons_Manager;

// Security Note: Blocks direct access to the plugin PHP files.
defined( 'ABSPATH' ) || die();

/**
 * Awesomesauce widget class.
 *
 * @since 1.0.0
 */ 
class Leadcapture_Construction_Abouts extends Widget_Base {
	
	/**
	 * Retrieve the widget name.
	 *
	 * @since 1.0.0
	 *
	 * @access public
	 *
	 * @return string Widget name.
	 */
	public function get_name() {
		return 'leadcapture_construction_abouts';
	}

	/**
	 * Retrieve the widget title.
	 *
	 * @since 1.0.0
	 *
	 * @access public
	 *
	 * @return string Widget title.
	 */
	public function get_title() {
		return __( 'Leadcapture Construction Abouts', 'leadcapture');
		
	}

	/**
	 * Retrieve the widget icon.
	 *
	 * @since 1.0.0
	 *
	 * @access public
	 *
	 * @return string Widget icon.
	 */
	public function get_icon() {
		return 'eicon-lightbox-expand';
	}

	/**
	 * Retrieve the list of categories the widget belongs to.
	 *
	 * Used to determine where to display the widget in the editor.
	 *
	 * Note that currently Elementor supports only one category.
	 * When multiple categories passed, Elementor uses the first one.
	 *
	 * @since 1.0.0
	 *
	 * @access public
	 *
	 * @return array Widget categories.
	 */
	public function get_categories() {
		return array( 'leadcapture-widget' );
	}
	
	/**
	 * Register the widget controls.
	 *
	 * Adds different input fields to allow the user to change and customize the widget settings.
	 *
	 * @since 1.0.0
	 *
	 * @access protected
	 */
	protected function register_controls() {
		$this->start_controls_section(
            'leadcapture_general',
            [
            'label' => esc_html__('About Us Settings', 'leadcapture' ),
            ] 
        );
		
        $this->add_control(
            'leadcapture_about_image_one',
            [
			'label' => esc_html__('About Image One', 'leadcapture'),
            'type'  => Controls_Manager::MEDIA,
            'label_block' => true,
			]
        );
         $this->add_control(
            'leadcapture_about_image_two',
            [
			'label' => esc_html__('About Image Two', 'leadcapture'),
            'type'  => Controls_Manager::MEDIA,
            'label_block' => true,
			]
        );
        $this->add_control(
            'leadcapture_experience',
            [
            'label' => esc_html__('Experience Year', 'leadcapture'),
            'type' => Controls_Manager::TEXT,
            'label_block' => true,
            'default' => esc_html__('', 'leadcapture'),
            ]
        );
        $this->add_control(
            'leadcapture_experience_text',
            [
            'label' => esc_html__('Experience Text', 'leadcapture'),
            'type' => Controls_Manager::TEXT,
            'label_block' => true,
            'default' => esc_html__('', 'leadcapture'),
            ]
        );
        $this->add_control(
            'leadcapture_ab_sub_head',
            [
            'label' => esc_html__('Sub Heading', 'leadcapture'),
            'type' => Controls_Manager::TEXT,
            'label_block' => true,
            'default' => esc_html__('', 'leadcapture'),
            ]
        );
        $this->add_control(
            'leadcapture_ab_main_head',
            [
            'label'  => esc_html__('Heading', 'leadcapture'),
            'type'   => Controls_Manager::TEXT,
            'label_block' => true,
            'default' => esc_html__('', 'leadcapture'),
            ]
        );

        $this->add_control(
            'leadcapture_ab_description_one',
            [
            'label' => esc_html__( 'Description First', 'leadcapture'),
            'type'  => Controls_Manager::TEXTAREA,
            'label_block' => true,
            'default' => esc_html__('', 'leadcapture'),
            ]
        );
        $this->add_control(
            'leadcapture_ab_description_two',
            [
            'label' => esc_html__( 'Description Second', 'leadcapture'),
            'type'  => Controls_Manager::TEXTAREA,
            'label_block' => true,
            'default' => esc_html__('', 'leadcapture'),
            ]
        );

        $this->add_control(
            'leadcapture_ab_button_text',
            [
            'label' => esc_html__('Button Text', 'leadcapture'),
            'type' => Controls_Manager::TEXT,
            'label_block' => true,
            'default'     => esc_html__('', 'leadcapture'),
            ]
        );

        $this->add_control(
            'leadcapture_ab_button_url',
            [
            'label' => esc_html__('Button Url', 'leadcapture'),
            'type'  => Controls_Manager::TEXT,
            'label_block' => true,
            'default' => esc_html__('', 'leadcapture'),
            ]
        );

       $this->end_controls_section();
       /** 
        * Lead Captur Style Tab
        */
        $this->start_controls_section(
            'lps_style_tab',
            [
            'label' => esc_html__( 'Style Tab', 'leadcapture'),
            'tab'   => Controls_Manager::TAB_STYLE,
            ]
        );
	    $this->add_group_control(
            Group_Control_Typography::get_type(),
            [   
            'label' => esc_html__('Heading Typography', 'leadcapture'),
            'name'     => 'lps_cons_ab_ab_heading_typography',
            'selector' => '{{WRAPPER}} .lps-heading-fontstyle',
            ]
        );
        $this->add_group_control(
            Group_Control_Typography::get_type(),
            [   
            'label' => esc_html__('Sub Heading Typography', 'leadcapture'),
            'name'     => 'lps_cons_ab_heading_typography',
            'selector' => '{{WRAPPER}} .lps-sub-heading-fontstyle',
            ]
        );
        $this->add_control(
        	'lps_cons_ab_heading_text_color',
        	[
        	'label' => esc_html__('Heading Text Color', 'leadcapture'),
        	'type' => \Elementor\Controls_Manager::COLOR,
        	'selectors' => [
        	   '{{WRAPPER}} .add-heading-text-colors' => 'color: {{VALUE}}',
        	 ],
           ]
        );
        $this->add_control(
        	'lps_cons_ab_sub_heading_text_color',
        	[
        	'label' => esc_html__('Sub Heading Text Color', 'leadcapture'),
        	'type' => \Elementor\Controls_Manager::COLOR,
        	'selectors' => [
        		'{{WRAPPER}} .add-sub-heading-text-colors' => 'color: {{VALUE}}',
        	  ],
        	]
        );
		$this->add_group_control(
            Group_Control_Typography::get_type(),
            [   
            'label' => esc_html__('Description Typography', 'leadcapture'),
            'name'     => 'lps_cons_ab_description_typography',
            'selector' => '{{WRAPPER}} .lps-description-fontstyle',
            ]
        ); 
        $this->add_control(
        	'lps_cons_ab_description_text_color',
        	[
        	'label' => esc_html__('Description Text Color', 'leadcapture'),
        	'type' => \Elementor\Controls_Manager::COLOR,
        	'selectors' => [
        		'{{WRAPPER}} .add-description-text-colors' => 'color: {{VALUE}}',
        	  ],
        	]
        );
        $this->add_control(
        	'lps_cons_ab_button_text_color',
        	[
        	'label' => esc_html__('Button Text Color', 'leadcapture'),
        	'type' => \Elementor\Controls_Manager::COLOR,
        	'selectors' => [
        		'{{WRAPPER}} .add-button-text-colors' => 'color: {{VALUE}}',
        	  ],
        	]
        );
        $this->add_control(
        	'lps_cons_ab_button_background_color',
        	[
        	'label' => esc_html__('Button Background Color', 'leadcapture'),
        	'type' => \Elementor\Controls_Manager::COLOR,
        	'selectors' => [
        		'{{WRAPPER}} .add-button-background-colors' => 'background-color: {{VALUE}}',
        	  ],
        	]
        );
        $this->add_control(
        	'lps_cons_ab_button_hover_color',
        	[
        	'label' => esc_html__('Button Hover Color', 'leadcapture'),
        	'type' => \Elementor\Controls_Manager::COLOR,
        	'selectors' => [
        		'{{WRAPPER}} .lc-btn-view-style11:hover' => 'background-color: {{VALUE}}',
        	  ],
        	]
        );
        $this->add_control(
        	'lps_cons_ab_button_border_color',
        	[
        	'label' => esc_html__('Button Border Color', 'leadcapture'),
        	'type' => \Elementor\Controls_Manager::COLOR,
        	'selectors' => [
        		'{{WRAPPER}} .lc-btn-view-style11:hover' => 'border-color: {{VALUE}}',
        	  ],
        	]
        );
        $this->add_control(
        	'lps_cons_ab_counter_background_color',
        	[
        	'label' => esc_html__('Counter Background Color', 'leadcapture'),
        	'type' => \Elementor\Controls_Manager::COLOR,
        	'selectors' => [
        		'{{WRAPPER}} .lc-text-box-wrapper-counter' => 'background-color: {{VALUE}}',
        	  ],
        	]
        );
        $this->end_controls_section();
	}
 
	/**
	 * Render the widget output on the frontend.
	 *
	 * Written in PHP and used to generate the final HTML.
	 *
	 * @since 1.0.0
	 *
	 * @access protected
	 */
	 
	protected function render() {
		$id = uniqid();	
		$settings = $this->get_settings_for_display();
		echo '<div class="lc-insurance-section lc-insurance-section-style11">
                <div class="container">
                    <div class="row">
                        <div class="col-lg-6 col-md-6 col-sm-12">
                            <div class="lc-image-wrapper">';
                                if(!empty($settings['leadcapture_about_image_one']['url'])):
                                echo '<img src="'.esc_url($settings['leadcapture_about_image_one']['url']).'" alt="'.esc_attr('About Image','leadcapture').'">';
                                endif;
                                if(!empty($settings['leadcapture_about_image_two']['url'])):
                                echo '<div class="lc-inner-image-wapper">
                                       <img src="'.esc_url($settings['leadcapture_about_image_two']['url']).'" alt="'.esc_attr('About Image','leadcapture').'">
                                     </div>';
                                endif;
                                if(!empty($settings['leadcapture_experience'])):
                                    echo '<div class="lc-text-box-wrapper lc-text-box-wrapper-counter">
                                          <div class="lc-number-box">
                                            <h2 class="lps-heading-fontstyle">'.esc_html($settings['leadcapture_experience']).'</h2>
                                        </div>';
                                if(!empty($settings['leadcapture_experience_text'])):
                                    echo '<div class="lc-text-box">
                                          <p class="lps-heading-fontstyle ">'.esc_html($settings['leadcapture_experience_text']).'</p>
                                         </div>';
                                endif; 
                                echo '</div>';
                                endif;
                                
                        echo '</div>
                        </div>
                        <div class="col-lg-6 col-md-6 col-sm-12">
                            <div class="lc-heading-wrapper lc-heading-wrapper-style11 ">';
                                if(!empty($settings['leadcapture_ab_sub_head'])):
                                echo '<h2 class="lps-sub-heading-fontstyle add-sub-heading-text-colors">'.esc_html($settings['leadcapture_ab_sub_head']).'</h2>';
                                endif;
                                if(!empty($settings['leadcapture_ab_main_head'])):
                                echo '<h1 class="add-heading-text-colors lps-heading-fontstyle">'.esc_html($settings['leadcapture_ab_main_head']).'</h1>';
                                endif;
                                if(!empty($settings['leadcapture_ab_description_one'])):   
                                  echo '<p class="lps-description-fontstyle add-description-text-colors">'.esc_html($settings['leadcapture_ab_description_one']).'</p>';
                                endif;
                                if(!empty($settings['leadcapture_ab_description_two'])):
                                  echo '<p class="lps-description-fontstyle add-description-text-colors">'.esc_html($settings['leadcapture_ab_description_two']).'</p>';
                                endif;  
                                if(!empty($settings['leadcapture_ab_button_text'])):
                                echo '<div class="lc-btn lc-btn-view-style11 add-button-background-colors">
                                        <a href="'.esc_url($settings['leadcapture_ab_button_url']).'" class="add-button-text-colors lps-description-fontstyle">'.esc_html($settings['leadcapture_ab_button_text']).'</a>
                                     </div>';
                                endif;
                        echo '</div>
                        </div>
                    </div>
                </div>
            </div>';
	}
}